{Ŀ}
{  IVS_VESA.PAS - VESA BIOS Driver - 320x200 24bit include file           }
{                  Work started     : 1998.08.01.                          }
{                  Last modification: 2001.07.02.                          }
{             OS - GO32V2                                                  }
{                                                                          }
{            IVS - Inquisition Video Server for Free Pascal                }
{                  Code by Karoly Balogh (a.k.a. Charlie/iNQ) and          }
{                          Marton Ekler (a.k.a. mrc!/iNQ)                  }
{                  Copyright (C) 1998-2001 Inquisition                     }
{}

Procedure VESA_Copy24Bit_Linear; Assembler;
Asm
 CMP VESA_BGRMode,1
 JNE @RGB_Copy

 {  BGR Mode  }
 @BGR_Copy:
  PUSH ES
  MOV  ESI,IVS_VirtualScreen
  MOV  ES,VESA_SegLFB
  MOV  EDI,VESA_PhysScrAddr
  MOV  ECX,32000
  @CycleHead:
   MOV EAX,[ESI]
   ADD ESI,4
   MOV EBX,[ESI]
   ADD ESI,4
   MOV EDX,EBX
   ROR EBX,8
   AND EAX,$00FFFFFF
   AND EBX,$FF000000
   OR  EAX,EBX
   MOV ES:[EDI],EAX  {  First Pixel + Second Pixel B  }
   ADD EDI,4
   SHR EDX,8
   MOV ES:[EDI],DX   {  Second Pixel GR  }
   ADD EDI,2
   DEC ECX
  JNZ  @CycleHead
  POP  ES
 JMP  @Exit

 {  RGB Mode  }
 @RGB_Copy:
  PUSH ES
  MOV  ESI,IVS_VirtualScreen
  MOV  ES,VESA_SegLFB
  MOV  EDI,VESA_PhysScrAddr
  MOV  ECX,32000
  @CycleHead2:
   MOV   EAX,[ESI]
   ADD   ESI,4
   BSWAP EAX
   MOV   EBX,[ESI]
   ADD   ESI,4

   MOV EDX,EBX
   SHR EAX,8
   SHL EBX,8
   AND EBX,$FF000000
   OR  EAX,EBX
   MOV ES:[EDI],EAX  {  First Pixel + Second Pixel R  }
   ADD EDI,4

   ROR  DX,8
   MOV  ES:[EDI],DX   {  Second Pixel GB  }
   ADD  EDI,2

   DEC ECX
  JNZ  @CycleHead2
  POP  ES

 @Exit:
End;

Procedure VESA_Copy24Bit_Banked; Assembler;
Asm
End;

{  320x200/24bit truecolor  }
Const VESA_LowResTrueColor24 : IVS_TVideoMode =
           (VMWidth  :320; VMHeight  :200;
            VMBFWidth:320; VMBFHeight:200;
            VMColours:16777216; VMBPP:24;
            VMName:'truecolor';
            VMMode:0;
            VMDoubleBuf:IVS_VMEnabled;
            VMVSync    :IVS_VMDisabled;
            VMAvailable:True;
            VMCopy_Banked:(CP_Normal  :@IVS_DummyProc;
                           CP_Scaled  :@IVS_DummyProc;
                           CP_Laced   :@IVS_DummyProc;
                           CP_Bilinear:@IVS_DummyProc);
            VMCopy_Linear:(CP_Normal  :@VESA_Copy24Bit_Linear;
                           CP_Scaled  :@IVS_DummyProc;
                           CP_Laced   :@IVS_DummyProc;
                           CP_Bilinear:@IVS_DummyProc));

{  VBE_LO24.PAS - (C) 1998-2001 Charlie/Inquisition et. al.  }
